<template>
  <single-pane
      class="contracts-list"
  >

    <ob-table
        ref="obTable"
        :columns="columns"
        :functional-panel="true"
        :remote-opt="{
          method: api.contract.getContractsList,
          arguments: {
            ...listRequestParams()
          }
        }"
        :remote-trigger="$route.name"
        sort-init="created_at:desc:datetime"
        :is-fixed-header="true"
        @select="onSelection"
    >

      <template slot="noneContent">
        <div class="title">
          {{noData($route.name)}}
        </div>
      </template>
      <template v-slot:number="{ data }">
        <div class="w-110">
          <template v-if="data.item.isChild">
            <div class="d-f jc-fe">
              <img src="./img/nested.svg" />
            </div>
          </template>
          <template v-else-if="!data.item.isTariffAgreement">
            <div class="contract-number">
              <ObTooltip
                  position="bottom-start"
                  :content="`Договор создан ${data.item.is_manual_created ? 'вручную' : 'автоматически'}`"
              >
                <i
                    class="icon"
                    :class="data.item.is_manual_created ? 'hand' : 'digital-document'"
                />
              </ObTooltip>
              <span>{{ data.item.number }}</span>
            </div>
          </template>
        </div>
      </template>
      <template v-slot:tariffAgreementNumber="{ data }">
        <div class="w-110">
          <template v-if="data.item.isTariffAgreement">
            <div class="contract-number">
              <ObTooltip
                  position="bottom-start"
                  :content="`Договор создан ${data.item.is_manual_created ? 'вручную' : 'автоматически'}`"
              >
                <i
                    class="icon"
                    :class="data.item.is_manual_created ? 'hand' : 'digital-document'"
                />
              </ObTooltip>
              <span>{{ data.item.number }}</span>
            </div>
          </template>
        </div>
      </template>
      <template v-slot:customerTitle="{ data }">
        <div class="contracts-list__icons">
          <i class="icon role-client"/>
          <span>{{data.item.client_title}}</span>
        </div>
      </template>
      <template v-slot:performer="{ data }">
        <div class="contracts-list__icons">
          <i class="icon " :class="[data.item.doer_title === owner ? 'role-domain-owner' : 'truck-sm']"/>
          <span>{{data.item.doer_title}}</span>
        </div>
      </template>
      <template v-slot:original_number="{ data }">
        <div
            :title="data.item.original_number"
            class="original-number"
        >
          {{data.item.original_number}}
        </div>
      </template>
<!--      <template v-slot:extraFuncToPanel>-->
<!--        <div class="contracts-list__select">-->
<!--          <div class="contracts-list__select-inline">-->
<!--            <span>Тип договора: </span>-->
<!--            <ob-inline-select-->
<!--                    v-model="typeContract.uuid"-->
<!--                    :items="typeContractItems"-->
<!--            />-->
<!--          </div>-->
<!--          <div class="contracts-list__select-inline">-->
<!--            <span>Заказчик: </span>-->
<!--            <ob-inline-select-->
<!--                    v-model="customer.uuid"-->
<!--                    :items="customers"-->
<!--            />-->
<!--          </div>-->
<!--          <div class="contracts-list__select-inline">-->
<!--            <span>Исполнитель: </span>-->
<!--            <ob-inline-select-->
<!--                    v-model="performer.uuid"-->
<!--                    :items="performers"-->
<!--            />-->
<!--          </div>-->
<!--        </div>-->
<!--      </template>-->
    </ob-table>
<!--    <Chat/>-->
  </single-pane>
</template>

<script>
  import moment from 'moment'
  import api from '@/api'
  import ObTable from 'common-components/src/obComponents/obTable'
  import ObInlineSelect from 'common-components/src/obComponents/obInlineSelect'
  import SinglePane from 'common-components/src/obComponents/obSinglePanels'
  import ObTooltip from "common-components/src/obComponents/obTooltip"
  //import Chat from '@/components/chat'

  export default {
    name: 'ContractList',
    components: {
      ObTable,
      // eslint-disable-next-line vue/no-unused-components
      ObInlineSelect,
      SinglePane,
      ObTooltip,
      //Chat
    },
    data() {
      return {
        owner: "ООО \"ОБОЗ ДИДЖИТАЛ\"",
        api,
        typeContract: {
          title: 'Все',
          uuid: '1'
        },
        typeContractItems: [
          {
            title: 'Все',
            uuid: '1'
          },
          {
            title: 'Перевозки',
            uuid: '2'
          }
        ],
        performer: {
          title: 'Все',
          uuid: '1'
        },
        performers: [
          {
            title: 'Все',
            uuid: '1'
          },
          {
            title: 'ООО "ЛЕРУА МЕРЛЕН ВОСТОК"',
            uuid: '2'
          }
        ],
        customer: {
          title: 'Все',
          uuid: '1'
        },
        customers: [
          {
            title: 'Все',
            uuid: '1'
          },
          {
            title: 'ООО "ОБОЗ ДИДЖИТАЛ"',
            uuid: '2'
          }
        ]
      }
    },
    computed: {
      columns() {
        return [
          {
            title: '№ договора',
            slotName: 'number',
            exactWidth: '160px'
          },
          {
            title: '№ тарифного соглашения',
            slotName: 'tariffAgreementNumber',
            exactWidth: '160px'
          },
          {
            title: 'Тип договора',
            key: 'contract_type_title'
          },
          {
            title: 'заказчик',
            key: 'client_title',
            slotName: 'customerTitle'
          },
          {
            title: 'Исполнитель',
            key: 'doer_title',
            slotName: 'performer'
          },
          {
            title: 'Внешний № договора',
            key: 'original_number',
            slotName: 'original_number',
            exactWidth: '100px'
          },
          {
            title: 'Создан',
            key: 'created_at',
            html: ({ created_at }) => this.getHtmlDatetime(created_at),
            isAlignRight: true
          },
          {
            title: 'действует с',
            key: 'from_date',
            html: ({ from_date }) => this.getHtmlDatetime(from_date, false),
            isAlignRight: true
          },
          {
            title: 'действует по',
            key: 'to_date',
            html: ({ to_date, isTimeless, is_timeless }) => this.getHtmlToDate(to_date, isTimeless || is_timeless),
            isAlignRight: true
          },
        ]
      }
    },
    methods: {
      noData(route) {
        switch (route) {
          case 'contracts__list-signing-from':
            return 'Здесь будут договоры, которые вам предлагают подписать';
          case 'contracts__list-signing-to':
            return 'Здесь будут договоры, которые должны подписать ваши контрагенты';
          case 'contracts__list-signed':
            return 'Здесь будут подписанные всеми участниками договоры';
          default:
            return 'Нет данных для отображения';
        }
      },
      getHtmlDatetime(datetime, isTime = true) {
        return datetime ? `
        <div class="field-datetime">
          <div>${moment(datetime).locale('ru').format('L')}</div>
          <div class="field-time ${isTime ? '' : 'hidden'}">${moment(datetime).locale('ru').format('LT')}</div>
        </div>
      ` : ''
      },
      getHtmlToDate(datetime, isTimeless = false) {
        if (isTimeless) return 'Бессрочно'

        return this.getHtmlDatetime(datetime, false)
      },
      onSelection(data) {
        this.$router.push({name: 'contracts__detail', params: {id: data.uuid}})
      },
      listRequestParams () {
        const urlMap = {
          'contracts__list-signing-from': {
            status: 'ON_SIGNING',
            direction: 'IN'
          },
          'contracts__list-signing-to': {
            status: 'ON_SIGNING',
            direction: 'OUT'
          },
          'contracts__list-signed': {
            status: 'SIGNED'
          },
        }

        return urlMap[this.$route.name] || {}
      }
    }
  }
</script>

<style lang="scss" scoped>
  .contract-number {
    display: flex;
    align-items: center;
    white-space: nowrap;
    .icon {
      margin-right: 12px;
      font-size: 14px;
      color: $color-blue-navy-blue;
    }
  }
  .original-number {
    max-width: 100px;
    overflow: hidden;
    white-space: nowrap;
    text-overflow: ellipsis;
  }
  .contracts-list {
    .w-110 {
      width: 110px!important;
    }
    &__tabs {
      display: inline-block;
      width: auto;
      padding: 10px 20px 0 20px;
    }

    &__icons {
      display: flex;
      align-items: center;

      i {
        padding-right: 13px;
        color: $blue-700;
      }
    }
    &__select {
      display: flex;
      align-items: center;
      width: 100%;
      &-inline {
        background: $blue-blue-hoarfrost;
        border-radius: 19px;
        padding: 5px 9px;
        font-size: 14px;
        line-height: 18px;
        letter-spacing: 0.2px;
        color: $color-grey-span;

        &:nth-child(1) {
          margin-right: 12px;
        }

        &:nth-child(2) {
          margin-right: 22px;
        }
      }
    }
  }
  ::v-deep .ob-func-panel{
    &__controls{
      justify-content: flex-start;
      &-side{
        &:first-child{
          .ob-func-panel__control{
            &:nth-child(1){
              display: none;
            }
            &:nth-child(2){
              display: none;
            }
          }
        }
        &:last-child{
          width: 100%;
          .ob-func-panel__control{
            &:first-child{
              width: 100%;
            }
          }
        }
      }
    }
  }
</style>

<style lang="scss">
  @import "~common-components/src/static/css/mixins";
  .contracts-list {

    .field-datetime {
      text-align: right;
      @include font-mixin(14px, 20px, 400);

      .field-time {
        color: $color-grey-span;

        &.hidden {
          display: none;
        }
      }
    }
  }
</style>
